struct Foo {
    static Func2<U>(u: U) : U {
        return u;
    }

    static Func<T>(t: T): T {
        foo: T = t;
        return Foo.Func2(foo);
    }
}

struct MemoryBlock<T>
{
	start: MemoryAddress;
	capacity: uint;

	AddressOf(count: uint): MemoryAddress
    {
        return start + (count * @sizeof<T>());
    }
}

struct Program {
    static Main(): int {
        x: int = 4;
        y: int = Foo.Func(x);
        block: MemoryBlock<int>;
        block.capacity = y;
        block.start = @malloc(y * @sizeof<int>());
        z: MemoryAddress = block.AddressOf(2);
        Console.PrintLine("%p", block.start);
        Console.PrintLine("%p", z);
        @free(block.start);
        return 0;
    }
}
